/*
 * Q[pbhŃ}EX
 * Copyright (C) 2014 m_inaba
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "COMCTL32.LIB")

#include <stdio.h>
#include <stdarg.h>
#include <process.h>
#include <windows.h>
#include <commctrl.h>

#include "resource.h"

#ifdef _DEBUG
#define DEBUG
#endif


#define MOUSEEVENTF_HWHEEL 0x01000
#define WM_USER_MSG	(WM_USER+100) //상bZ[W
#define WM_USER_MSG2	(WM_USER+101) //상bZ[W
#define WM_USER_MSG3	(WM_USER+102) //상bZ[W

#define SOFTNAME "Q[pbhŃ}EX Ver,0.1"

BOOL CALLBACK DlgProc(HWND,UINT,WPARAM,LPARAM);
void main_loop(void);
void save(void);
void load(void);
void show(HWND);

//`Ԃ̌ y=yi + (yi+1-yi)(x-xi)/(xi+1-xi)
#define INTERP(xi,xi1,yi,yi1,x) (yi + ((( yi1 - yi ) * ( x - xi )) / ( xi1 - xi )))

//}EX̉
const int ar[]={
/* x */   0,   10,  20,  30,  40,  50,  60,  70,0x7FFFFFFF,
/* y */   0,    0,   1,   4,   8,  10,  16,  32,        32
};
const int ar_w=(sizeof(ar)/sizeof(ar[0]))/2;


//AiÕ}EX̉
//ő吔0x7FFFFFFF͕KvȂ͂Ȃ̂ƍőlȏŕsRȓ(VC6̃[Xrĥ)
//VC2010Express̃RpCł͋NȂBsx̍œKĂ悤BiԂj
const int analog_ar[]={
/* x */   0, 4681, 9362,14043,18724,23405,28086,32767,0x7FFFFFFF,
/* y */   0,    0,    0,    1,    2,    4,    7,   10,        10
};
const int analog_ar_w=(sizeof(analog_ar)/sizeof(analog_ar[0]))/2;


//zC[̉
const int h_ar[]={
/* x */    0, 20,  30,  40,  50,  60,  70,  80,  90,0x7FFFFFFF,
/* y */    1,  2,   4,   8,  10,  12,  15,  20,  40,        40
};
const int h_ar_w=(sizeof(h_ar)/sizeof(h_ar[0]))/2;


//AiÕzC[̉
const int h_analog_ar[]={
/* x */   0, 4681, 9362,14043,18724,23405,28086,32767,0x7FFFFFFF,
/* y */   1,    2,    4,    8,   10,   15,   20,   40,        40
};
const int h_analog_ar_w=(sizeof(h_analog_ar)/sizeof(h_analog_ar[0]))/2;

//` x:Ԃl ar: w:̉̒
int interp1dim(const int x,const int*ar,const int w){
	int i;
	//x̒l͈͊Ȍꍇxőŏl̒lԂ
	if(x<=ar[0]){
		return ar[w];
	}else if(x>=ar[w-1]){
		return ar[w*2-1];
	}
	
	for(i=1;i<w;i++){
		if(ar[i]>=x) break;
	}
	// y=yi + (yi+1-yi)(x-xi)/(xi+1-xi) slԂ
	return INTERP(ar[i-1],ar[i],ar[i+w-1],ar[i+w],x);
}

int bit_serch(int n){
	 for(int i=0;i<32;i++){
		if( n & (1<< i) ){
			return i+1;
		}
	}
	return 0;
}

JOYINFOEX JoyInfoEx;
char str[256];
HWND hWnd;
unsigned int button_disable;

unsigned long data1,data2,data3,data4,data5,data6,setting1,setting2,setting3;


#ifdef DEBUG
HANDLE hIn;
HANDLE hOut;
HANDLE hErr;
#endif

int printf(const char*str,...){
#ifdef DEBUG
	char pos[128];
	int r;
	va_list ap;
	va_start(ap,str);
	r=vsprintf(pos,str,ap);
	//R\[ւ̏o
	WriteFile(hOut,pos,strlen(pos),NULL,NULL);
	va_end(ap);//ψXg̏I
	return r;
#else
	return 0;
#endif
}

int WINAPI WinMain(HINSTANCE hCurInst,HINSTANCE hPrevInst,
					LPSTR lpsCmdLine,int nCmdShow ){
	
	HANDLE m_hMutex;  //~[ebNXIuWFNg̃nh
	m_hMutex = CreateMutex(NULL, TRUE, "gemepaddemouse");
	if ( GetLastError() == ERROR_ALREADY_EXISTS ){
		//ɓOŋNĂꍇ
		//NɏI鏈ɏ
		MessageBox(NULL,"dNĂ܂\n^XNgCɓĂ܂񂩁H",SOFTNAME,0);
		return 0; 
	}
	
	InitCommonControls();//RRg[̏
	JoyInfoEx.dwSize = sizeof(JOYINFOEX);
	JoyInfoEx.dwFlags = JOY_RETURNALL;

#ifdef DEBUG
	//R\[쐬
	FreeConsole();
	AllocConsole();
	hIn = GetStdHandle(STD_INPUT_HANDLE);
	hOut = GetStdHandle(STD_OUTPUT_HANDLE);
	hErr = GetStdHandle(STD_ERROR_HANDLE);
#endif
	load();
	_beginthread((void(*)(void *))main_loop,0,0);
	DialogBox(hCurInst,MAKEINTRESOURCE(IDD_DIALOG1),NULL,(DLGPROC)DlgProc);
	//̃EChE_CAO\ꍇ́A
	//[_ɂꍇ͑3NULLeWHNDn悤ɕύX
	//WHNDnȂꍇA[hXɂȂ邪_CAOJĂԁAeEBhETABSTOPȂǂ삵Ȃ
	ReleaseMutex(m_hMutex);
	return 0;
}

namespace NTFYICON{
	NOTIFYICONDATA m_stNtfyIcon;
	//^XNgCɃACR쐬
	void setNtfiIcon(HWND hWnd,char*str){
		m_stNtfyIcon.cbSize = sizeof( NOTIFYICONDATA );
		m_stNtfyIcon.uID = 0;
		m_stNtfyIcon.hWnd = hWnd;
		m_stNtfyIcon.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
		m_stNtfyIcon.hIcon = (HICON)SendMessage(hWnd, WM_GETICON, ICON_SMALL, 0);
		m_stNtfyIcon.uCallbackMessage = WM_USER_MSG;
		lstrcpy( m_stNtfyIcon.szTip,str);
		Shell_NotifyIcon( NIM_ADD, &m_stNtfyIcon );
	}
	//^XNgC̃ACR폜
	void eraseNtfiIcon(){
		Shell_NotifyIcon( NIM_DELETE, &m_stNtfyIcon );
	}
}


WNDPROC DefaultProc;

LRESULT CALLBACK SubProc(HWND sub_hWnd,UINT msg,WPARAM wp,LPARAM lp){
	switch (msg){
		case WM_RBUTTONDOWN://ENbN𖳌ɂ
		case WM_RBUTTONDBLCLK:
		case WM_RBUTTONUP:
			return 0;
		case WM_KILLFOCUS:
			InvalidateRect(sub_hWnd, NULL,1);
			UpdateWindow(sub_hWnd);
			break;
	}
	//̃vV[WĂяo
	return CallWindowProc(DefaultProc,sub_hWnd,msg,wp,lp);
}



RECT rc;

//_CAOvV[W[
BOOL CALLBACK DlgProc(HWND hDlg,UINT msg,WPARAM wp,LPARAM lp){
	switch (msg){
		case WM_INITDIALOG:
			{
				hWnd=hDlg;
				HWND hCont1;
				for(int i=IDC_EDIT1;i<=IDC_EDIT6;i++){
					hCont1=GetDlgItem(hDlg,i);
					DefaultProc=(WNDPROC)GetWindowLong(hCont1, GWL_WNDPROC);
					SetWindowLong(hCont1,GWL_WNDPROC,(LONG)SubProc);
				}

				HWND hBar = GetDlgItem(hDlg,IDC_SLIDER1);
				SendMessage(hBar,TBM_SETRANGE,TRUE,MAKELPARAM(1,15));//Ww
				SendMessage(hBar,TBM_SETPAGESIZE,0,1);//NbN̈ړ
				hBar = GetDlgItem(hDlg,IDC_SLIDER2);
				SendMessage(hBar,TBM_SETRANGE,TRUE,MAKELPARAM(1,15));//Ww
				SendMessage(hBar,TBM_SETPAGESIZE,0,1);//NbN̈ړ

				SetWindowText(hDlg,SOFTNAME);
			}
			break;
		case WM_SHOWWINDOW:
			printf("WM_SHOWWINDOW\n");
			{
				static int i;
				if(0==i){
					i=1;
					SendMessage(hDlg, WM_SETICON,NULL,(LPARAM)LoadIcon((HINSTANCE)GetWindowLong(hDlg, GWL_HINSTANCE),  MAKEINTRESOURCE(IDI_ICON1)));//_CAOɃACRt
					NTFYICON::setNtfiIcon(hDlg,SOFTNAME);//^XNgCɃACR𐶐 \镶:test
					SetTimer(hDlg,1001,0,NULL);
					GetWindowRect(hDlg,&rc);
					SetWindowPos(hDlg,NULL,0,0,0,0,SWP_HIDEWINDOW);
				}
			}
			show(hDlg);
			break;
		case WM_CREATE:
			//ShowWindow(hDlg,SW_HIDE);

			break;
		case WM_USER_MSG2:
			KillTimer(hDlg,1000);//^C}[j
			break;
		case WM_USER_MSG3:
			SetTimer(hDlg,1000,100,NULL);
			break;
		case WM_USER_MSG://^XNgC̃ACR̃bZ[W
			switch(lp)
			{
			case WM_RBUTTONDOWN:
				{
					POINT pt;
					GetCursorPos(&pt);
					HMENU menu=LoadMenu((HINSTANCE)GetWindowLong(hDlg, GWL_HINSTANCE),MAKEINTRESOURCE(IDR_MENU1));
					TrackPopupMenu(GetSubMenu(menu,0),TPM_LEFTALIGN,/* X */pt.x,/* Y */pt.y,NULL,hDlg,NULL);
					DestroyMenu(menu);
				}
				break;
			case WM_LBUTTONDOWN:
				//button_disable=1;
				SetTimer(hDlg,1000,30,NULL);
				SetWindowPos(hDlg,NULL,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,SWP_SHOWWINDOW);
				break;
			}
			break;
		case WM_TIMER:
			if(wp == 1000){
				if(JOYERR_NOERROR == joyGetPosEx(0, &JoyInfoEx)){ //0Ԃ̃WCXeBbN̏
					sprintf(str,"Xe[^X : ڑĂ܂ 0x%x   %d{^",JoyInfoEx.dwButtons,bit_serch(JoyInfoEx.dwButtons));
					SetWindowText(GetDlgItem(hDlg,IDSTATUS),str);

					HWND ctrl_hwnd=GetFocus();
					int id=GetDlgCtrlID(ctrl_hwnd);
					if(!(IDC_EDIT1<=id && IDC_EDIT6>=id))	break;

					sprintf(str,"0x%x\t%d{^",JoyInfoEx.dwButtons,bit_serch(JoyInfoEx.dwButtons));
					
					static unsigned long old_dwButtons;
					static int old_id,count;
					static unsigned long old_time;
					unsigned long time=timeGetTime();
					if(old_dwButtons==JoyInfoEx.dwButtons && old_id==id){
						//300msȏ㓯{^Ăꍇ͕ύX
						if(300<time-old_time){
							if(0!=JoyInfoEx.dwButtons){
								SetWindowText(ctrl_hwnd,str);
							}
						}
					}else{
						old_time=time;
						old_dwButtons=JoyInfoEx.dwButtons;
						old_id=id;
					}
				  }else{
					sprintf(str,"Xe[^X : %s","G[ Q[pbhڑă\tgċNĂ");
					SetWindowText(GetDlgItem(hDlg,IDSTATUS),str);
				}
			}else if(1001==wp){
				ShowWindow(hDlg,SW_HIDE);
				KillTimer(hDlg,1001);
			}
			break;
		case WM_CTLCOLOREDIT://Edit ̔wiF
			{
				static HBRUSH bkColorBrush=CreateSolidBrush(RGB(200,255,255));//wiF̃uVpӂ
				//lpɊeRg[̃nhĂ܂B
				//lpĊeX̃Rg[̐Fς܂
				if(lp==(long)GetFocus()){
					SetBkMode(((HDC)wp),TRANSPARENT);
					SetTextColor (((HDC)wp),RGB(200,0,0));//̐F
					return (LRESULT)bkColorBrush;
				}
			}
			break;
		case WM_COMMAND:
			switch (LOWORD(wp)){
				case IDOK:
					GetWindowRect(hDlg,&rc);
					SetWindowPos(hDlg,NULL,0,0,0,0,SWP_HIDEWINDOW);
					KillTimer(hDlg,1000);//^C}[j
				case IDAPPLY:
					GetWindowText(GetDlgItem(hDlg,IDC_EDIT1),str,100);
					data1=strtol(str,NULL,0);
					GetWindowText(GetDlgItem(hDlg,IDC_EDIT2),str,100);
					data2=strtol(str,NULL,0);
					GetWindowText(GetDlgItem(hDlg,IDC_EDIT3),str,100);
					data3=strtol(str,NULL,0);
					GetWindowText(GetDlgItem(hDlg,IDC_EDIT4),str,100);
					data4=strtol(str,NULL,0);
					GetWindowText(GetDlgItem(hDlg,IDC_EDIT5),str,100);
					data5=strtol(str,NULL,0);
					GetWindowText(GetDlgItem(hDlg,IDC_EDIT6),str,100);
					data6=strtol(str,NULL,0);
					setting1=SendMessage(GetDlgItem(hDlg,IDC_CHECK1),BM_GETCHECK,NULL,NULL);
					setting2=SendMessage(GetDlgItem(hDlg,IDC_SLIDER1),TBM_GETPOS,NULL,NULL);
					setting3=SendMessage(GetDlgItem(hDlg,IDC_SLIDER2),TBM_GETPOS,NULL,NULL);
					save();
					break;
				case IDCANCEL:
					GetWindowRect(hDlg,&rc);
					SetWindowPos(hDlg,NULL,0,0,0,0,SWP_HIDEWINDOW);
					KillTimer(hDlg,1000);//^C}[j
					load();
					show(hDlg);
					break;
				case ID_MENUITEM40003:
					SetTimer(hDlg,1000,30,NULL);
					SetWindowPos(hDlg,NULL,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,SWP_SHOWWINDOW);
					break;
				case ID_MENUITEM40004:
				case IDEND:
					KillTimer(hDlg,1000);//^C}[j
					NTFYICON::eraseNtfiIcon();//^XNgC̃ACR폜
					EndDialog(hDlg,WM_CLOSE);
					break;
			}
			break;
		case WM_HSCROLL:
			if(GetDlgItem(hDlg,IDC_SLIDER1)==(HWND)lp){
					setting2=SendMessage(GetDlgItem(hDlg,IDC_SLIDER1),TBM_GETPOS,NULL,NULL);
			}else if(GetDlgItem(hDlg,IDC_SLIDER2)==(HWND)lp){
					setting3=SendMessage(GetDlgItem(hDlg,IDC_SLIDER2),TBM_GETPOS,NULL,NULL);
			}
			break;
		case WM_CLOSE:
			//button_disable=0;
			GetWindowRect(hDlg,&rc);
			SetWindowPos(hDlg,NULL,0,0,0,0,SWP_HIDEWINDOW);
			KillTimer(hDlg,1000);//^C}[j
		break;
	}
	return FALSE;
}


void main_loop(void){
	unsigned long old_dwButtons=0;
	long acc=0;
	long analog_mode=0;
	long stick2=0;
	long v_h_acc=0;
	long h_h_acc=0;

	unsigned long wheel_r,wheel_l,wheel_u,wheel_d;
	unsigned long button_r,button_l;

	while(1){
//		_printf("%d %d\n",h_h_acc,interp1dim(h_h_acc,h_ar,h_ar_w));

		button_l=data1;
		button_r=data2;
		wheel_u=data3;
		wheel_d=data4;
		wheel_l=data5;
		wheel_r=data6;

		
		if(JOYERR_NOERROR == joyGetPosEx(0, &JoyInfoEx)){ //0Ԃ̃WCXeBbN̏

			if(v_h_acc<200) v_h_acc++;
			if(wheel_u&JoyInfoEx.dwButtons){
				mouse_event(MOUSEEVENTF_WHEEL,0,0,interp1dim(v_h_acc,h_ar,h_ar_w)*(int)setting3,0);
			}else if(wheel_d&JoyInfoEx.dwButtons){
				mouse_event(MOUSEEVENTF_WHEEL,0,0,-(interp1dim(v_h_acc,h_ar,h_ar_w)*(int)setting3),0);
			}else{
				v_h_acc=0;
			}
			//cXN[𓯎ɓȂ
			if(!(setting1 && ((wheel_u&JoyInfoEx.dwButtons) || (wheel_d&JoyInfoEx.dwButtons)))){
				if(h_h_acc<200) h_h_acc++;
				if(wheel_l&JoyInfoEx.dwButtons){
					mouse_event(MOUSEEVENTF_HWHEEL,0,0,-(interp1dim(h_h_acc,h_ar,h_ar_w)*(int)setting3),0);
				}else if(wheel_r&JoyInfoEx.dwButtons){
					mouse_event(MOUSEEVENTF_HWHEEL,0,0,interp1dim(h_h_acc,h_ar,h_ar_w)*(int)setting3,0);
				}else{
					h_h_acc=0;
				}
			}			

			//if(!button_disable){
				if(button_l&JoyInfoEx.dwButtons){
					if(!(button_l&old_dwButtons)) mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,0,0);
				}else if(button_l&old_dwButtons){
					mouse_event(MOUSEEVENTF_LEFTUP,0,0,0,0);
				}
					
				if(button_r&JoyInfoEx.dwButtons){
					if(!(button_r&old_dwButtons)) mouse_event(MOUSEEVENTF_RIGHTDOWN,0,0,0,0);
				}else if(button_r&old_dwButtons){
					mouse_event(MOUSEEVENTF_RIGHTUP,0,0,0,0);
				}

				old_dwButtons=JoyInfoEx.dwButtons;
			//}

			if(acc<200) acc++;
			if(((0x7fff+0xfff>JoyInfoEx.dwXpos) && (0x7fff-0xfff<JoyInfoEx.dwXpos)) &&
				((0x7fff+0xfff>JoyInfoEx.dwYpos) && (0x7fff-0xfff<JoyInfoEx.dwYpos))){
				acc=0;
				analog_mode=0;
			}

			if(!(((0x7fff+0xfff>JoyInfoEx.dwXpos) && (0x7fff-0xfff<JoyInfoEx.dwXpos) || (0==JoyInfoEx.dwXpos) || (0xFFFF==JoyInfoEx.dwXpos)) &&
			     ((0x7fff+0xfff>JoyInfoEx.dwYpos) && (0x7fff-0xfff<JoyInfoEx.dwYpos) || (0==JoyInfoEx.dwYpos) || (0xFFFF==JoyInfoEx.dwYpos)))){
				analog_mode=1;
			}

//			printf("analog_mode = %d\n",analog_mode);

			if(analog_mode){
				if(0x7fff+0xfff<JoyInfoEx.dwXpos){
					POINT pt;
					//}EX݂̌̍W擾
					GetCursorPos(&pt);
					//}EẌʒuړ
					int pos=(interp1dim(JoyInfoEx.dwXpos-0x7fff,analog_ar,analog_ar_w)*(int)setting2);
					if(!pos) pos=1;
					printf("%d %d\n",interp1dim(JoyInfoEx.dwXpos-0x7fff,analog_ar,analog_ar_w),pos);
					SetCursorPos(pt.x+pos,pt.y);
				}else if(0x7fff-0xfff>JoyInfoEx.dwXpos){
					POINT pt;
					//}EX݂̌̍W擾
					GetCursorPos(&pt);
					//}EẌʒuړ
					int pos=(interp1dim(0x7fff-JoyInfoEx.dwXpos,analog_ar,analog_ar_w)*(int)setting2);
					if(!pos) pos=1;
					SetCursorPos(pt.x-pos,pt.y);
				}

				if(0x7fff+0xfff<JoyInfoEx.dwYpos){
					POINT pt;
					//}EX݂̌̍W擾
					GetCursorPos(&pt);
					//}EẌʒuړ
					int pos=(interp1dim(JoyInfoEx.dwYpos-0x7fff,analog_ar,analog_ar_w)*(int)setting2);
					if(!pos) pos=1;
					SetCursorPos(pt.x,pt.y+pos);
				}else if(0x7fff-0xfff>JoyInfoEx.dwYpos){
					POINT pt;
					//}EX݂̌̍W擾
					GetCursorPos(&pt);
					int pos=(interp1dim(0x7fff-JoyInfoEx.dwYpos,analog_ar,analog_ar_w)*(int)setting2);
					if(!pos) pos=1;
					//}EẌʒuړ
					SetCursorPos(pt.x,pt.y-pos);
				}
			}else{
				if(0x7fff+0xfff<JoyInfoEx.dwXpos){
					POINT pt;
					//}EX݂̌̍W擾
					GetCursorPos(&pt);
					//}EẌʒuړ
					int pos=(interp1dim(acc,ar,ar_w)*(int)setting2);
					if(!pos) pos=1;
					SetCursorPos(pt.x+pos,pt.y);
				}else if(0x7fff-0xfff>JoyInfoEx.dwXpos){
					POINT pt;
					//}EX݂̌̍W擾
					GetCursorPos(&pt);
					//}EẌʒuړ
					int pos=(interp1dim(acc,ar,ar_w)*(int)setting2);
					if(!pos) pos=1;
					SetCursorPos(pt.x-pos,pt.y);
				}

				if(0x7fff+0xfff<JoyInfoEx.dwYpos){
					POINT pt;
					//}EX݂̌̍W擾
					GetCursorPos(&pt);
					//}EẌʒuړ
					int pos=(interp1dim(acc,ar,ar_w)*(int)setting2);
					if(!pos) pos=1;
					SetCursorPos(pt.x,pt.y+pos);
				}else if(0x7fff-0xfff>JoyInfoEx.dwYpos){
					POINT pt;
					//}EX݂̌̍W擾
					GetCursorPos(&pt);
					//}EẌʒuړ
					int pos=(interp1dim(acc,ar,ar_w)*(int)setting2);
					if(!pos) pos=1;
					SetCursorPos(pt.x,pt.y-pos);
				}
			}

			//WCXeBbNQ݂邩ǂ
			if(0!=JoyInfoEx.dwZpos || 0!=JoyInfoEx.dwRpos) stick2=1;
			if(stick2){
				if(0x7fff+0xfff<JoyInfoEx.dwRpos){
					mouse_event(MOUSEEVENTF_WHEEL,0,0,-(interp1dim(JoyInfoEx.dwRpos-0x7fff,h_analog_ar,h_analog_ar_w)*(int)setting3),0);
				}else if(0x7fff-0xfff>JoyInfoEx.dwRpos){
					mouse_event(MOUSEEVENTF_WHEEL,0,0,(interp1dim(0x7fff-JoyInfoEx.dwRpos,h_analog_ar,h_analog_ar_w)*(int)setting3),0);
				}
				//cXN[𓯎ɓȂ
				if(!(setting1 && ((0x7fff+0xfff<JoyInfoEx.dwRpos) || (0x7fff-0xfff>JoyInfoEx.dwRpos)))){
					if(0x7fff+0xfff<JoyInfoEx.dwZpos){
						mouse_event(MOUSEEVENTF_HWHEEL,0,0,interp1dim(JoyInfoEx.dwZpos-0x7fff,h_analog_ar,h_analog_ar_w)*(int)setting3,0);
					}else if(0x7fff-0xfff>JoyInfoEx.dwZpos){
						mouse_event(MOUSEEVENTF_HWHEEL,0,0,-(interp1dim(0x7fff-JoyInfoEx.dwZpos,h_analog_ar,h_analog_ar_w)*(int)setting3),0);
					}
				}
			}
/*
			printf("dwXpos = 0x%x\t"
				"dwYpos = 0x%x\t"
				"dwButtons = 0x%x\n",
				JoyInfoEx.dwXpos,
				JoyInfoEx.dwYpos,
				JoyInfoEx.dwButtons);
			printf("%x %x\n",JoyInfoEx.dwZpos,JoyInfoEx.dwRpos);
*/
		  }else{
			printf("G[\n");
		}

		  //30msŃX[v悤ɂ鏈
		static unsigned long sleep_time=1;
		unsigned long sleep_start=timeGetTime();
		Sleep(sleep_time);
		unsigned long sleep_end=timeGetTime();
		if(35<sleep_end-sleep_start){
			sleep_time--;
		}else if(28>sleep_end-sleep_start){
			sleep_time++;
		}
		if(5>sleep_time) sleep_time=5;
//		_printf("%d %d\n",sleep_end-sleep_start,sleep_time);

	}
}


//data1,data2,data3,data4,data5,data6ۑ
void save(void){
	HKEY hKey;
	DWORD dwDisposition;
	LONG result;
	result = RegCreateKeyEx( HKEY_CURRENT_USER,
				"Software\\gamepad_de_mouse\\1",//L[
				0,//\
				NULL,//w
				REG_OPTION_NON_VOLATILE,//s
				KEY_ALL_ACCESS,
				NULL,
				&hKey,
				&dwDisposition);
	//result  ERROR_SUCCESS łΐłD
	if(ERROR_SUCCESS!=result){
		MessageBox(NULL,"f[^[ۑs","WXgɃANZXł܂ł",0);
		return;
	}

	RegSetValueEx(hKey,"data1",0,REG_DWORD,(CONST BYTE*)&data1,(int)sizeof(data1));
	RegSetValueEx(hKey,"data2",0,REG_DWORD,(CONST BYTE*)&data2,(int)sizeof(data1));
	RegSetValueEx(hKey,"data3",0,REG_DWORD,(CONST BYTE*)&data3,(int)sizeof(data1));
	RegSetValueEx(hKey,"data4",0,REG_DWORD,(CONST BYTE*)&data4,(int)sizeof(data1));
	RegSetValueEx(hKey,"data5",0,REG_DWORD,(CONST BYTE*)&data5,(int)sizeof(data1));
	RegSetValueEx(hKey,"data6",0,REG_DWORD,(CONST BYTE*)&data6,(int)sizeof(data1));

	RegSetValueEx(hKey,"setting1",0,REG_DWORD,(CONST BYTE*)&setting1,(int)sizeof(data1));
	RegSetValueEx(hKey,"setting2",0,REG_DWORD,(CONST BYTE*)&setting2,(int)sizeof(data1));
	RegSetValueEx(hKey,"setting3",0,REG_DWORD,(CONST BYTE*)&setting3,(int)sizeof(data1));


	RegCloseKey(hKey);
}

//data1,data2,data3,data4,data5,data6ǂݏo
void load(void){
	data1=0x10;data2=0x40;
	data3=0x02;data4=0x04;
	data5=0x01;data6=0x08;
	setting1=1;
	setting2=2;
	setting3=2;

	HKEY hKey;
	DWORD dwDisposition;
	LONG result;
	result = RegCreateKeyEx( HKEY_CURRENT_USER,
				"Software\\gamepad_de_mouse\\1",//L[
				0,//\
				NULL,//w
				REG_OPTION_NON_VOLATILE,//s
				KEY_ALL_ACCESS,
				NULL,
				&hKey,
				&dwDisposition);
	//result  ERROR_SUCCESS łΐłD
	if(ERROR_SUCCESS!=result){
		MessageBox(NULL,"f[^[ǂݏos","WXgɃANZXł܂ł",0);
		return;
	}

	DWORD dwSize=(int)sizeof(data1);
	RegQueryValueEx(hKey,"data1",NULL,NULL,(LPBYTE)&data1,&dwSize);
	RegQueryValueEx(hKey,"data2",NULL,NULL,(LPBYTE)&data2,&dwSize);
	RegQueryValueEx(hKey,"data3",NULL,NULL,(LPBYTE)&data3,&dwSize);
	RegQueryValueEx(hKey,"data4",NULL,NULL,(LPBYTE)&data4,&dwSize);
	RegQueryValueEx(hKey,"data5",NULL,NULL,(LPBYTE)&data5,&dwSize);
	RegQueryValueEx(hKey,"data6",NULL,NULL,(LPBYTE)&data6,&dwSize);

	RegQueryValueEx(hKey,"setting1",NULL,NULL,(LPBYTE)&setting1,&dwSize);
	RegQueryValueEx(hKey,"setting2",NULL,NULL,(LPBYTE)&setting2,&dwSize);
	RegQueryValueEx(hKey,"setting3",NULL,NULL,(LPBYTE)&setting3,&dwSize);

	RegCloseKey(hKey);
}

void show(HWND hDlg){
	//data1=1;data2=2;data3=3;data4=4;data5=5;data6=6;
	sprintf(str,"0x%x\t%d{^ ",data1,bit_serch(data1));
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT1),str);
	sprintf(str,"0x%x\t%d{^ ",data2,bit_serch(data2));
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT2),str);
	sprintf(str,"0x%x\t%d{^ ",data3,bit_serch(data3));
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT3),str);
	sprintf(str,"0x%x\t%d{^ ",data4,bit_serch(data4));
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT4),str);
	sprintf(str,"0x%x\t%d{^ ",data5,bit_serch(data5));
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT5),str);
	sprintf(str,"0x%x\t%d{^ ",data6,bit_serch(data6));
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT6),str);
	PostMessage(GetDlgItem(hDlg,IDC_CHECK1),BM_SETCHECK,setting1,NULL);
	SendMessage(GetDlgItem(hDlg,IDC_SLIDER1),TBM_SETPOS,TRUE,setting2);
	SendMessage(GetDlgItem(hDlg,IDC_SLIDER2),TBM_SETPOS,TRUE,setting3);
}
